Subject: RE: [DNA] RE: Review of link-information from Pekka Savola

From: [email-masked]
Date: Tue, 03 May 2005 10:54:17 +0300

Hi Tero,

> > A Linux machine cannot see the PDP context that has been setup by
> > the phone.  If the phone has multiple PDP for applications running
> > on the phone, those are not available to a laptop, for example.
> 
> True. Actually I meant that if the node is using a GPRS card, which
> means that the node runs PPP to the card. If the card has multiple PDP
> contexts, are those mapped as several PPP connections or are they still
> within the same PPP connection? Because if they are within the same
> connection, how does the card know which context to use for an outgoing
> packet?

That sounds like a driver issue.  I haven't played with GPRS cards that
support multiple PDP contexts.
 
> > Phones running the Symbian OS have way of handling these multiple
> > PDP contexts; there are a number of other embedded operator systems
> > that handle these in a vendor specified manner.
> > 
> > So, I think we have two cases here:
> > 
> > 1) Laptop case which uses PPP from the laptop, no open issues here,
> >    I think.
> > 2) Phone application case: some issues here, I think.
> > 
> > What I assume we want to do is "detect network attachment" on the links.  For
> > 2G & 3G GPRS, the link is essentially a PDP context.  There are two types of
> > PDP contexts, a Primary PDP Context and a Secondary PDP Context.Secondary
> > PDP contexts get their IP address from the Primary PDP context.
> 
> Here I refer to a previous mail of mine where I mentioned the  discussion
> with Jari. The motivation of DNA can also be seen as a way to find an
> answer to the question: "I was previously using this address, can I
> still use it on this network too?" On a phone where PDP  contexts are not
> hidden from the application there should not be any reason to ask that
> question because the node gets an address in the PDP context and then
> just applies that. If it differs from the previous one, well, then it
> does. Hmm ... maybe we have to run MobileIPvX on a phone too :)

PDP Contexts can have the following state:
1) Active - resources & IP address allocated, traffic flow possible
2) Suspended - resources & IP address allocated, traffic suspended
3) inactive - no resources & no IP address allocate

However, even with an active PDP context, it is possible that the link isn't
active; for example if the GGSN goes down, then UE might still be in the 
PDP Context active state but there are no resources available.  

To repeat your question:

> The motivation of DNA can also be seen as a way to find an
> answer to the question: "I was previously using this address, can I
> still use it on this network too?"

You would need to re-run DNA everytime the PDP context state is changed, in
my opinion.

John

---

From: Jari Arkko <[email-masked]>
Date: Tue, 03 May 2005 11:44:50 +0300

Hi John,

>PDP Context active state but there are no resources available.  
But isn't IPv6 NUD the right protocol to use when ensuring
that you still have connectivity to the GGSN? At least that's
what we wrote in RFC 3316...

>You would need to re-run DNA everytime the PDP context state is changed, in
The way that I see this is that the point of DNA is to detect
changes in (a) prefixes that affect the host's addresses, and
(b) routers that the host uses as default routers.

Now, when you are on a point-to-point link such as PDP context
or PPP, there isn't much use for part b, so we are primarily interested
in part a.

My understanding of the PDP context procedure is that in
the establishment procedure (that runs on lower layers) you
get a prefix that is unique to you. Furthermore, as specified
in RFC 3316 there are some rules that prevent the same
interface ID from being assigned on the same link; that's
why DupAddrDetectTransmits can be set to zero.

My understanding is also that the 3GPP specifications
require the network to never change the prefixes on
a live PDP context (or if they are changed, the context
needs to be shut down first).

As a result, I have trouble seeing why we'd need to run
DNA on a phone that is connected to a GSM/UMTS network
via a PDP context. NUD yes. L2 signaling to set up yes.
But no DNA. Or am I missing something?

(On a laptop connected over PPP this is a different matter.
The laptop has no knowledge of what the L2 really is at the
other end.)

--Jari

---

From: Greg Daley <[email-masked]>
Date: Wed, 04 May 2005 11:04:54 +1000

Hi John,

[email-masked] wrote:
[chop]
> PDP Context active state but there are no resources available.  

Right.  Not all of these are associated with hints from GPRS though.

Some of these will be determined through 'other' hints like timeouts
or packet reception/non-reception at other layers.

> You would need to re-run DNA everytime the PDP context state is changed, in

If you receive a credible hint from your own L2 stack that PDP context
state has changed, then I think that DNA (of whichever form v4/v6)
is necessary.

Please have a look at section 5 (particularly 5.(0) and 5.1) in the
hosts BCP (draft-ietf-dna-hosts-00). This has recently changed in
response to review that there was no explicit actions prescribed in
the previous version.

Do these sub-sections provide sufficient information to hosts as to
what to do in this case?

Greg